library ieee;
use ieee.std_logic_1164.all;
use work.DE2_CONSTANTS.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- SIGNED and UNSIGNED types, and relevant functions
use ieee.numeric_std.all;

-- Basic sequential functions and concurrent procedures
use ieee.VITAL_Primitives.all;
entity direction_controller is
   port(off1:in std_logic;
	     clk1:in std_logic;
		  reset_n:in std_logic;
		  direction1:in std_logic;
		  enable:out std_logic;
		  phase:out std_logic_vector(3 downto 0);
		  avs_s0_read_n	: in std_logic ;
		  avs_s0_readdata : out std_logic_vector (31 downto 0)
		  );
end entity direction_controller;

architecture arc1 of direction_controller is
   type motor_states is (a,ab,b,bc,c,cd,d,da);
	--type enableStates is (run,stop);
	signal current_state:motor_states;
	--signal enable_state:enableStates;
	signal step_counter:std_logic_vector (31 downto 0):="01111111111111111111111111111111";
	begin 
	   process(clk1)
		   begin
			  if clk1' event and clk1='1' then
			    if reset_n='1' then 
				   current_state<=a;
							--enable<='1';
					step_counter<="01111111111111111111111111111111";
				 else
				   case current_state is
	-------------------------a--------------------------------				
	 when a=>
						  if off1='1' then
						  if direction1='1' then
						   current_state<=ab;
							step_counter<=step_counter+1;
						  elsif direction1='0' then
						    current_state<=da;
						    step_counter<=step_counter-1;
						  end if;
						  elsif off1='0' then
						    step_counter<=step_counter;
				    end if;
   -----------------------ab----------------------------------
	 when ab=>
						  if off1='1' then
						  if direction1='1' then
						    current_state<=b;
							 step_counter<=step_counter+1;
						  elsif direction1='0' then
						    current_state<=a;
						    step_counter<=step_counter-1;
						  		--enable<='1';
				    end if;
					 elsif off1='0' then
					 step_counter<=step_counter;
					 			    end if;
	-----------------------b-----------------------------------
	 when b=>
						if off1='1' then  
						 if direction1='1' then
						    current_state<=bc;
							 step_counter<=step_counter+1;
						  elsif direction1='0' then
						  current_state<=ab;
						  step_counter<=step_counter-1;
end if;
step_counter<=step_counter;
end if;
	-----------------------bc----------------------------------
	 when bc=>
						if off1='1' then 
						  if direction1='1' then
						    current_state<=c;
						  step_counter<=step_counter+1;
						  		--enable<='1';
						  elsif direction1='0' then
						  current_state<=b;
						  step_counter<=step_counter-1;
						  		--enable<='1';
				    end if;
					 step_counter<=step_counter;
					 end if;
	-----------------------c-----------------------------------
	 when c=>
					if off1='1' then 
						  if direction1='1' then
						  step_counter<=step_counter+1;
						 		--enable<='1';
						    current_state<=cd;
						  elsif direction1='0' then
						  current_state<=bc;
						  step_counter<=step_counter-1;
						  		--enable<='1';
				    end if;
					 step_counter<=step_counter;
					 end if;
	-----------------------cd----------------------------------
	 when cd=>
					if off1='1' then 
						  if direction1='1' then
						    current_state<=d;
							step_counter<=step_counter+1;
					  elsif direction1='0' then
					  current_state<=c;
					  step_counter<=step_counter-1;
				   end if;
					step_counter<=step_counter;
					end if;
	-----------------------d-----------------------------------
	 when d=>
					if off1='1' then 
					  if direction1='1' then
						    current_state<=da;
							step_counter<=step_counter+1;
								--enable<='1';
					  elsif direction1='0' then
					  current_state<=cd;
					  step_counter<=step_counter-1;
					  		--enable<='1';
end if;
step_counter<=step_counter;
end if;
	-----------------------da----------------------------------
	 when da=> 
						if off1='1' then 
						  if direction1='1' then
						    current_state<=a;
							 step_counter<=step_counter+1;
							 		--enable<='1';
						  elsif direction1='0' then
						  current_state<=d;
						  step_counter<=step_counter-1;
						  		--enable<='1';
				    end if;
					 step_counter<=step_counter;
					 end if;
	-----------------------others------------------------------
	when others => current_state<=a;
	
	end case;
	end if;
	end if;
	end process;
	
	process(current_state)
	    begin
		 case current_state is
		  when a=> phase<="1000";
		  when ab=> phase<="1100";
		  when b=> phase<="0100";
		  when bc=> phase<="0110";
		  when c=> phase<="0010";
		  when cd=> phase<="0011";
		  when d=> phase<="0001";
		  when da=> phase<="1001";
		  	when others => current_state<=a;
		end case;
            if off1='1' then
            		enable<='1';
               --phase<="0000"; --which means no motion,it doesnt means go back to origin
	  --position cuz origin position should be 1000
	         else 
				   		enable<='0';
	      end if;
	    end process;
----------------------------------------------------------------------------------------------------------------------------
--        process(reset_n,avs_s0_read_n) is
--			
--          begin
--		
--            if ( reset_n = '0' ) then
--				 case current_state is
--	-------------------------a--------------------------------				
--	 when a=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=ab;
--                                                   step_counter<=step_counter-1;
--																	enable_state<=run;
--                                                else
--					           current_state<=da;
--						   step_counter<=step_counter-1;
--							end if;
--                                            else
--                                                   enable_state<=run;
--                                         end if;
--   -----------------------ab----------------------------------
--	 when ab=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=b;
--                                                   step_counter<=step_counter-1;
--																	enable_state<=run;
--                                                else
--					           current_state<=a;
--						   step_counter<=step_counter-1;
--							 end if;
--                                            else
--                                                  enable_state<=run;
--				              
--                                         end if;
--	-----------------------b-----------------------------------
--	 when b=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=bc;
--							enable_state<=run;
--                                                   step_counter<=step_counter-1;
--                                                else
--					           current_state<=ab;
--						   step_counter<=step_counter-1;
--							 end if;
--                                            else
--                                                   enable_state<=run;
--				              
--                                         end if;
--	-----------------------bc----------------------------------
--	 when bc=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=c;
--							enable_state<=run;
--                                                   step_counter<=step_counter-1;
--                                                else
--					           current_state<=b;
--						   step_counter<=step_counter-1;
--							  end if;
--                                            else
--                                                   enable_state<=run;
--				             
--                                         end if;
--	-----------------------c-----------------------------------
--	 when c=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=cd;
--							enable_state<=run;
--                                                   step_counter<=step_counter-1;
--                                                else
--					           current_state<=bc;
--						   step_counter<=step_counter-1;
--							 end if;
--                                            else
--                                                   enable_state<=run;
--				              
--                                         end if;
--	-----------------------cd----------------------------------
--	 when cd=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=d;
--							enable_state<=run;
--                                                   step_counter<=step_counter-1;
--                                       else
--					           current_state<=c;
--						   step_counter<=step_counter-1;
--							end if;
--                                            else
--                                                   enable_state<=run;
--				               
--                                         end if;
--	-----------------------d-----------------------------------
--	 	 when d=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=da;
--							enable_state<=run;
--                                                   step_counter<=step_counter-1;
--                                                else
--					           current_state<=cd;
--						   step_counter<=step_counter-1;
--							      end if;
--                                            else
--                                                   enable_state<=run;
--				         
--                                         end if;
--	-----------------------da----------------------------------
--	 when da=>
--		                            if step_counter>"01111111111111111111111111111111" then				  
--						if direction1='1' then
--						   current_state<=a;
--							enable_state<=run;
--                                                   step_counter<=step_counter-1;
--                                                else
--					           current_state<=d;
--						   step_counter<=step_counter-1;
--							end if;
--                                            else
--                                                   enable_state<=run;
--				               
--                                         end if;
--	-----------------------others------------------------------
--	when others => current_state<=a;
--	
--	end case;					
--		elsif (avs_s0_read_n = '0') then
--				avs_s0_readdata <= step_counter;
--		else 
--		-- reset block
--			
--                end if;
--	
--            end process;
process(avs_s0_read_n) is
begin
   if(avs_s0_read_n='0' ) then
	 avs_s0_readdata<=step_counter;
	else
	end if;
end process;

--  process(enable_state) is 
--  begin 
--    case enable_state is
--	  when run=> enable<='1';
--	 when stop=> enable<='0';
--	 when others => enable_state<=run;
--		  
--		end case;
--	 end process;
       end architecture arc1;
-----------------------------------------------------------------------------------------------------------------------------------	  
