library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
--use work.DE2_CONSTANTS.all;

-- SIGNED and UNSIGNED types, and relevant functions
use ieee.numeric_std.all;

-- Basic sequential functions and concurrent procedures
use ieee.VITAL_Primitives.all;
entity motor_controller is
  port(coe_off:in std_logic;
       clk:in std_logic;
		 reset:in std_logic;
		 coe_direction:in std_logic;
		 coe_enable:out std_logic;
		 coe_phaseout:out std_logic_vector(3 downto 0);
		 coe_factor_a:in std_logic_vector(31 downto 0);
		 avs_s0_read_n	: in std_logic ;
		 avs_s0_readdata : out std_logic_vector (31 downto 0));
end entity motor_controller;
 


architecture adjustment of motor_controller is
component frequency_divider
	port( clk_in:in std_logic;
		   reset :in std_logic;
		   coe_clkout:out std_logic;
			factor_a:in std_logic_vector(31 downto 0));
	end component;

component direction_controller
  port(off1:in std_logic;
	     clk1:in std_logic;
		  reset_n:in std_logic;
		  direction1:in std_logic;
		  enable:out std_logic;
		  phase:out std_logic_vector(3 downto 0);
		  avs_s0_read_n	: in std_logic ;
		  avs_s0_readdata : out std_logic_vector (31 downto 0)
		  );  
  end component;
    signal e:std_logic;
	 
   begin
	  u1:frequency_divider
	  port map(clk,reset,e,coe_factor_a);
	  u2:direction_controller port map(
	     coe_off,e,reset,coe_direction,coe_enable,coe_phaseout,avs_s0_read_n,avs_s0_readdata);


end architecture adjustment;
	           